app-term-kit
============

This gives you a few features for your app:

- action centric structure (`<app-name> <action> <other stuff>`)
- automatic handling of commented JSON config files and setting values therein
- automatic handling of optional `~/.<app-name>` directories (and easy init)
- automatic handling of classes of plugins installed in `~/.<app-name>`
    - simple require shim for plugin loading
    - automated installation and (eventually) maintenance
- handle ansi configuration of [`yargs`]() and adding some features/simplifications
    - handle flag collisions
    - (eventually) formatting widths to terminal width
- rights notifications & licensing information
- (eventually) [man pages](https://gist.github.com/dominikwilkowski/cba6c8c6b1ded8d3e3cc6bf0b7ddc432)
- (eventually) test harness (use common tests/data between CLI and Classes)

Installation
------------

```bash
npm install app-term-kit
```

Usage
-----

```js
var app = new CLApp('app-name', {
    copyright : 'Ed Beggler',
    copystart : '2020',
    defaults : `{
  // This file was autogenerated by app-name
  //
  "name": "robble-rauser",
  "type": "*",
  "debug": false
}`
});
```

```js
app.command({});
```

```js
app.argument({});
```

```js
app.help();
```

```js
app.header({});
```

```js
app.footer({});
```

```js
app.plugins({}, cb);
```

```js
app.useable(cb);
```

```js
app.config(cb);
```

```js
app.run(cb);
```

Roadmap
-------
[More to come]
